local addon, ns = ...
local cfg = ns.cfg
local realValue = 1
local min, max = math.min, math.max 

local CC = cfg.classColor
local completeQuestsTitle = {}
local completeQuestsXP = 0
local W = cfg.powerNxpBar.width
local H = cfg.powerNxpBar.height

------------------------------------------------------
-- CREATE BARS
------------------------------------------------------
	local mainBar = CreateFrame("Frame",nil, UIParent)
	mainBar:SetSize(W, H)
	
	mainBar.bg = mainBar:CreateTexture(nil,"BACKGROUND",nil,-8)
	mainBar.bg:SetAllPoints()
	mainBar.bg:SetTexture(cfg.mediaFolder.."statusbar")
	mainBar.bg:SetVertexColor(0,0,0, .6)

	local BGshadow = CreateFrame('Frame', nil, mainBar, BackdropTemplateMixin and "BackdropTemplate")
	BGshadow:SetPoint('TOPLEFT', -4, 4)
	BGshadow:SetPoint('BOTTOMRIGHT', 4, -4)
	BGshadow:SetBackdrop({
		edgeFile = cfg.mediaFolder.."textureGlow", edgeSize = 4,
		insets = {left = 4, right = 4, top = 4, bottom = 4}
	})
	BGshadow:SetBackdropBorderColor(0,0,0)

	mainBar.statusbar = mainBar:CreateTexture(nil,"OVERLAY",nil,-5)
	mainBar.statusbar:SetTexture(cfg.mediaFolder.."statusbar")
	mainBar.statusbar:SetSize(1, H)
	mainBar.statusbar:SetPoint("BOTTOM")

	mainBar.sparkL = mainBar:CreateTexture(nil,"OVERLAY",nil,-4)
	mainBar.sparkL:SetWidth(1)
	mainBar.sparkL:SetColorTexture(0,0,0, .7)
	mainBar.sparkL:SetPoint("TOPLEFT",mainBar.statusbar)
	mainBar.sparkL:SetPoint("BOTTOMLEFT",mainBar.statusbar)

	mainBar.sparkR = mainBar:CreateTexture(nil,"OVERLAY",nil,-4)
	mainBar.sparkR:SetWidth(1)
	mainBar.sparkR:SetColorTexture(0,0,0, .7)
	mainBar.sparkR:SetPoint("TOPRIGHT",mainBar.statusbar)
	mainBar.sparkR:SetPoint("BOTTOMRIGHT",mainBar.statusbar)

	mainBar.gainbar = mainBar:CreateTexture(nil,"OVERLAY",nil,-7)
	mainBar.gainbar:SetTexture(cfg.mediaFolder.."statusbar")
	mainBar.gainbar:SetPoint("CENTER")
	mainBar.gainbar:SetSize(1, H)
	mainBar.gainbar:SetVertexColor(CC.r*.8, CC.g*.8, CC.b*.8, .3)

	mainBar.sparkLgainbar = mainBar:CreateTexture(nil,"OVERLAY",nil,-6)
	mainBar.sparkLgainbar:SetSize(1,H)
	mainBar.sparkLgainbar:SetPoint("LEFT", mainBar.gainbar)
	mainBar.sparkLgainbar:SetColorTexture(CC.r*.3, CC.g*.3, CC.b*.3)

	mainBar.sparkRgainbar = mainBar:CreateTexture(nil,"OVERLAY",nil,-6)
	mainBar.sparkRgainbar:SetSize(1,H)
	mainBar.sparkRgainbar:SetPoint("RIGHT",mainBar.gainbar)
	mainBar.sparkRgainbar:SetColorTexture(CC.r*.3, CC.g*.3, CC.b*.3)

	mainBar.restbar = mainBar:CreateTexture(nil,"BACKGROUND",nil,-3)
	mainBar.restbar:SetTexture(cfg.mediaFolder.."statusbar")
	mainBar.restbar:SetPoint("CENTER")
	mainBar.restbar:SetSize(1,H)
	mainBar.restbar:SetVertexColor(.5,.5,.5, .3)
	mainBar.restbar:SetAlpha(0)

	mainBar.restSparkL = mainBar:CreateTexture(nil,"BACKGROUND",nil,-2)
	mainBar.restSparkL:SetSize(1,H)
	mainBar.restSparkL:SetColorTexture(0,0,0, .7)
	mainBar.restSparkL:SetPoint("LEFT",mainBar.restbar)

	mainBar.restSparkR = mainBar:CreateTexture(nil,"BACKGROUND",nil,-2)
	mainBar.restSparkR:SetSize(1,H)
	mainBar.restSparkR:SetColorTexture(0,0,0, .7)
	mainBar.restSparkR:SetPoint("RIGHT",mainBar.restbar)

	------------------------------------------------------
	-- CREATE ORB
	------------------------------------------------------
	local orbS = 45
	local orb = CreateFrame("BUTTON", nil, mainBar)
	orb:SetSize(orbS/2, orbS/2)
	orb:SetPoint("CENTER")
	orb:SetFrameLevel(5)
	orb:RegisterForClicks("AnyUp")

	orb.bg = orb:CreateTexture(nil,"BACKGROUND",nil,-8)
	orb.bg:SetSize(orbS, orbS)
	orb.bg:SetTexture(cfg.mediaFolder.."xpNpowerCenter")
	orb.bg:SetTexCoord(.032, 1, 0, 1)	
	orb.bg:SetPoint("CENTER")

	orb.fill = orb:CreateTexture(nil,"BACKGROUND",nil,-7)
	orb.fill:SetSize(orbS/3, orbS/3)
	orb.fill:SetTexture(cfg.mediaFolder.."xpNpowerOrb")
	orb.fill:SetPoint("CENTER")
	orb.fill:SetTexCoord(.032, 1, 0, 1)
	orb.fill:SetVertexColor(cfg.classColor.r,cfg.classColor.g,cfg.classColor.b, 1)

	orb.glow = orb:CreateTexture(nil,"BACKGROUND",nil,-6)
	orb.glow:SetSize(orbS, orbS)
	orb.glow:SetTexture(cfg.mediaFolder.."xpNpowerGlow")
	orb.glow:SetPoint("CENTER")
	orb.glow:SetTexCoord(.032, 1, 0, 1)	
	orb.glow:SetAlpha(0)

	orb.textC = orb:CreateFontString(nil, "OVERLAY")
	orb.textC:SetFont(STANDARD_TEXT_FONT, cfg.powerNxpBar.fontsize, "THINOUTLINE")
	orb.textC:SetPoint("BOTTOM", orb, "TOP", 0,2)
	orb.textC:SetJustifyH("CENTER")
	orb.textC:Hide()

	orb.textL = orb:CreateFontString(nil, "OVERLAY")
	orb.textL:SetFont(STANDARD_TEXT_FONT, cfg.powerNxpBar.fontsize, "THINOUTLINE")
	orb.textL:SetPoint("RIGHT", orb, "CENTER", -20, 0)
	orb.textL:SetJustifyH("RIGHT")
	orb.textL:Hide()

	orb.textR = orb:CreateFontString(nil, "OVERLAY")
	orb.textR:SetFont(STANDARD_TEXT_FONT, cfg.powerNxpBar.fontsize, "THINOUTLINE")
	orb.textR:SetPoint("LEFT", orb, "CENTER", 20, 0)
	orb.textR:SetJustifyH("LEFT")
	orb.textR:Hide()

------------------------------------------------------
-- UPDATE FUNC
------------------------------------------------------
local function showText()
	orb.textC:Show()
	orb.textL:Show()
	orb.textR:Show()
end 

local function hideText()
	orb.textC:Hide()
	orb.textL:Hide()
	orb.textR:Hide()
end

local function updateRest()
	local mxp = UnitXPMax("player")
	local xp = UnitXP("player")
	local rxp = GetXPExhaustion()
			
	if rxp then
		mainBar.restbar:SetAlpha(.4)
		realValue = xp/mxp
		if rxp+xp >= mxp then
			mainBar.restbar:SetWidth(W)
		else
			mainBar.restbar:SetWidth((W+orbS)*(rxp+xp)/mxp)
		end
	else
		mainBar.restbar:SetAlpha(0)
	end
end

local function updateXP()
	local 	mxp = UnitXPMax("player")
	local 	xp = UnitXP("player")
	local	rxp = GetXPExhaustion()
	realValue = xp/mxp
		
	if UnitLevel("player") == MAX_PLAYER_LEVEL then
		realValue = 0
	else
		orb.textC:SetText(floor((realValue)*100) .."%")
		orb.textL:SetText("xp: "..format(cfg.SVal(xp)).." / "..format(cfg.SVal(mxp)))
		if rxp then
			mainBar.restbar:SetAlpha(.4)
			orb.textR:SetText("rest: "..floor((rxp/mxp)*1000)/10 .."%")
		else
			mainBar.restbar:SetAlpha(0)
			orb.textR:SetText(format(cfg.SVal(mxp-xp)))
		end
	end
	updateRest()
end

local function questXpGain()
	completeQuestsTitle = table.wipe(completeQuestsTitle)
	completeQuestsXP = 0

	for i=1,C_QuestLog.GetNumQuestLogEntries() do
		local quest = C_QuestLog.GetInfo(i)
		if C_QuestLog.IsComplete(quest.questID) then
			if GetQuestLogRewardXP(quest.questID)/UnitXPMax("player")*100 > 2 then -- need more than n% xp to count
				completeQuestsXP = completeQuestsXP + GetQuestLogRewardXP(quest.questID)
				table.insert(completeQuestsTitle, {quest.title, GetQuestLogRewardXP(quest.questID)} )		
			end
		end
	end
	
	if completeQuestsXP > 0 then
		--if UnitLevel("player") ~= MAX_PLAYER_LEVEL then GameTooltip:AddLine(" ") end
		for index, content in pairs(completeQuestsTitle) do
			local questName, questReward = unpack(content)
			if UnitLevel("player") == MAX_PLAYER_LEVEL then
				mainBar.gainbar:SetWidth(1)
			else
				if completeQuestsXP > (UnitXPMax("player") - UnitXP("player")) then
					mainBar.gainbar:SetWidth(W)
				else 
					mainBar.gainbar:SetWidth(mainBar.statusbar:GetWidth()*(completeQuestsXP+UnitXPMax("player"))/UnitXPMax("player"))
				end
			end
		end
	end
	
	--print("Checking Quests")	
	
end

local function updateRep()
	local name, standing, minrep, maxrep, value = GetWatchedFactionInfo()
	if name then
		mainBar.restbar:SetAlpha(0)
		if maxrep > 0 then realValue = (value-minrep)/(maxrep-minrep) end
		orb.textC:SetText(floor(realValue*100) .."%")
		orb.textL:SetText(format(cfg.SVal(value-minrep)).." / "..format(cfg.SVal(maxrep-minrep)))
		orb.textR:SetText(getglobal("FACTION_STANDING_LABEL"..standing).." with "..name)
	else
		realValue = 0
		updateXP()
	end
end

local function overOrbTooltip()
	if InCombatLockdown() then return end
	local mxp = UnitXPMax("player")
	local xp = UnitXP("player")
	local nxp = mxp - xp
	local rxp = GetXPExhaustion()
	local name, standing, minrep, maxrep, value = GetWatchedFactionInfo()

	GameTooltip:SetOwner(orb, "ANCHOR_TOP")
	GameTooltip:AddLine("|cff6699FFSXUI Advancement bar")
	GameTooltip:AddLine(" ")
-- EXPERIENCE
	if UnitLevel("player") ~= MAX_PLAYER_LEVEL then
		GameTooltip:AddDoubleLine("Level", UnitLevel("player"),CC.r,CC.g,CC.b, 1,1,1)
		GameTooltip:AddDoubleLine(COMBAT_XP_GAIN, format(cfg.SVal(xp)).."|cffffd100/|r"..format(cfg.SVal(mxp)).." |cffffd100/|r "..floor((xp/mxp)*100).."%",CC.r,CC.g,CC.b,1,1,1)
		GameTooltip:AddDoubleLine(NEED, format(cfg.SVal(nxp)).." |cffffd100/|r "..floor((nxp/mxp)*100).."%",CC.r,CC.g,CC.b,1,1,1)
		if rxp then
			GameTooltip:AddDoubleLine(TUTORIAL_TITLE26, format(cfg.SVal(rxp)) .." |cffffd100/|r ".. floor((rxp/mxp)*100).."%", CC.r,CC.g,CC.b,1,1,1)
		end	
	end
-- QUEST	
	if completeQuestsXP > 0 then
		if UnitLevel("player") ~= MAX_PLAYER_LEVEL then GameTooltip:AddLine(" ") end
		GameTooltip:AddDoubleLine("Quest Complete:", #completeQuestsTitle, CC.r,CC.g,CC.b,1,1,1)
		if IsShiftKeyDown() then
			for index, content in pairs(completeQuestsTitle) do
				local questName, questReward = unpack(content)
				if UnitLevel("player") == MAX_PLAYER_LEVEL then
					GameTooltip:AddLine("      "..questName, 1,1,0)
				else
					GameTooltip:AddDoubleLine("      "..questName, format(cfg.SVal(questReward)), 1,1,0, 1,1,1)
				end
			end
		end
	end
		
	if UnitLevel("player") ~= MAX_PLAYER_LEVEL and #completeQuestsTitle > 0  then	
		GameTooltip:AddDoubleLine("Quest XP:", format(cfg.SVal(completeQuestsXP)).." |cffffd100/|r "..floor((completeQuestsXP/mxp)*100).."%" , CC.r,CC.g,CC.b,1,1,1)
		if completeQuestsXP > nxp then
			GameTooltip:AddLine("You have enough quest XP to level up", 1,1,0)
		end
	end

-- REPUTATION
	if name then
		GameTooltip:AddLine(" ")
		GameTooltip:AddDoubleLine(FACTION, name, CC.r,CC.g,CC.b,1,1,1)
		GameTooltip:AddDoubleLine(STANDING, getglobal("FACTION_STANDING_LABEL"..standing), CC.r,CC.g,CC.b,FACTION_BAR_COLORS[standing].r, FACTION_BAR_COLORS[standing].g, FACTION_BAR_COLORS[standing].b)
		GameTooltip:AddDoubleLine(REPUTATION, format(cfg.SVal(value-minrep)) .."|cffffd100/|r"..format(cfg.SVal(maxrep-minrep)).." |cffffd100/|r "..floor((value-minrep)/(maxrep-minrep)*100).."%", CC.r,CC.g,CC.b,1,1,1)
		nrep = maxrep - value
		GameTooltip:AddDoubleLine(NEED, format(cfg.SVal(nrep)).." |cffffd100/|r "..floor((nrep/maxrep)*100) .."%",CC.r,CC.g,CC.b,1,1,1)
	end
	
	if #completeQuestsTitle > 0 and not IsShiftKeyDown() then 
		GameTooltip:AddLine(" ") 
		GameTooltip:AddDoubleLine("<hold-shift>", "More info", 1,1,0,1,1,1) 
	end
	questXpGain()
	GameTooltip:Show()
end

local eventframe = CreateFrame("Frame")
eventframe:RegisterEvent("PLAYER_ENTERING_WORLD")
eventframe:RegisterEvent("PLAYER_UPDATE_RESTING")
eventframe:RegisterEvent("PLAYER_REGEN_DISABLED")
eventframe:RegisterEvent("PLAYER_REGEN_ENABLED")
eventframe:RegisterEvent("PLAYER_XP_UPDATE")
eventframe:RegisterEvent("PLAYER_LEVEL_UP")
eventframe:RegisterEvent("QUEST_LOG_UPDATE")
eventframe:RegisterEvent("UPDATE_FACTION")
eventframe:RegisterEvent("MODIFIER_STATE_CHANGED")

eventframe:SetScript("OnEvent", function(this, event, arg1, arg2, arg3, arg4, ...)
	local mxp = UnitXPMax("player")
	local xp = UnitXP("player")
	local rxp = GetXPExhaustion()
	local name, standing, minrep, maxrep, value = GetWatchedFactionInfo()
	
	if event == "QUEST_LOG_UPDATE" then

	elseif event == "MODIFIER_STATE_CHANGED" or event == "PLAYER_ENTERING_WORLD" then
		if InCombatLockdown() then return end
		if arg1 == "LCTRL" or arg1 == "RCTRL" then
			if arg2 == 1 then
				updateRep()
				mainBar.gainbar:SetWidth(1)
				if name then
					orb.fill:SetVertexColor(FACTION_BAR_COLORS[standing].r, FACTION_BAR_COLORS[standing].g, FACTION_BAR_COLORS[standing].b)
					orb.glow:SetVertexColor(orb.fill:GetVertexColor())
				end
			else
				if UnitLevel("player") ~= MAX_PLAYER_LEVEL then
					updateXP() 
					C_Timer.After(.1, questXpGain)
					orb.fill:SetVertexColor(cfg.classColor.r,cfg.classColor.g,cfg.classColor.b, 1)
					orb.glow:SetVertexColor(orb.fill:GetVertexColor())
				end
			end
	elseif arg1 == "LSHIFT" or arg1 == "RSHIFT" then
		if IsControlKeyDown() then updateRep() end	
		if orb:IsMouseOver() then overOrbTooltip() end
		if arg2 == 1 then 
			showText() 
		else
			hideText()
		end
	else
		if UnitLevel("player") == MAX_PLAYER_LEVEL then
			updateRep()
		else
			updateXP()
		end
	end
	end
end)

orb:SetScript("OnEnter", function()
	overOrbTooltip()
end)

orb:SetScript("OnLeave", function() 
	GameTooltip:Hide()
end)

--PRETTY AND FUNCTION
local timer, glow, red, green, blue, fadeAway = 0, 1
orb:SetScript("OnUpdate", function(self, elapsed)

	local limit = 30/GetFramerate()
	local offset = W-orbS/2
	local value = orbS/2 + realValue*offset
	local cur = mainBar.statusbar:GetWidth()
	local new = cur + min((value-cur)/3, max(value-cur, limit))
	if new ~= new then
		new = value
	end
	mainBar.statusbar:SetWidth(new)
	
	if cur == value or abs(new - value) < 2 then
		mainBar.statusbar:SetWidth(value)
	end
	
	timer = timer + elapsed
	if timer > 0.1 then
		glow = fadeAway and glow - 0.02 or glow + 0.02
		
		red, green, blue = orb.fill:GetVertexColor()
		
		if glow > 1 then
			fadeAway = true
		elseif glow < 0.60 then
			fadeAway = false
		end
		
		mainBar.statusbar:SetVertexColor(red* glow, green * glow, blue 	* glow)
		
		if IsResting() then 
			orb.glow:SetScale(glow+0.35)
		else 
			orb.glow:SetScale(.87)
		end
			
		timer = 0
	end
end)

if cfg.testing then
	mainBar:SetScale(1.8)
	mainBar:SetPoint("CENTER", 0, 100)
	
	local mainSlider = cfg.sliderTemplate("testHealth", mainBar, 256, "MainBar", 0, 100, 100,"BOTTOM",0,-70)
	mainSlider.tooltipText = "Sets the value of the main bar"
			
	mainSlider:SetScript("OnValueChanged", function(self, value)
		realValue = value/100
		self.editBox:SetText(floor(value))
	end)

else 
	mainBar:SetPoint(cfg.powerNxpBar.pos.point, cfg.powerNxpBar.pos.X, cfg.powerNxpBar.pos.Y)
end

