--get the addon namespace
local addon, ns = ...

--object container
local cfg = {}
ns.cfg = cfg
-- FOR TESTING --
cfg.testing = false

-- STATIC INFO --
cfg.mediaFolder = "Interface\\AddOns\\"..addon.."\\media\\"
cfg.font = STANDARD_TEXT_FONT
cfg.CLASS = select(2, UnitClass("player"))
cfg.classColor = (CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS)[cfg.CLASS]

-- YOU CAN CHANGE THESE --
cfg.useClassColor = true
cfg.powerNxpBar = {
	color = {
		r = 1, 
		g = 1,
		b = 0
	},
	height = 8,
	width = 700,
	fontsize = 12,
	pos = {
		point = "BOTTOM",
		X = 0, 
		Y = 75
	},
}

--FUNCTIONS--
if not cfg.useClassColor then
cfg.classColor.r = cfg.powerNxpBar.color.r
cfg.classColor.g = cfg.powerNxpBar.color.g
cfg.classColor.b = cfg.powerNxpBar.color.b
end

cfg.SVal = function(val)
	if val > 1E10 then
		return (floor(val/1E9)).."|rb"
	elseif val > 1E9 then
		return (floor((val/1E9)*10)/10).."|rb"
	elseif val > 1E7 then
		return (floor(val/1E6)).."|rm"
	elseif val > 1E6 then
		return (floor((val/1E6)*10)/10).."|rm"
	elseif val > 1E4 then
		return (floor(val/1E3)).."|rk"
	elseif val >= 1E3 then
		return (floor(val/1E3)) .. (" %03d"):format(val % 1E3)
	else
		return (floor(val))
	end
end

function cfg.sliderTemplate(sliderName, sliderParent, sliderWidth, sliderText, sliderMinValue, sliderMaxValue, sliderStartValue, ...)
		local sliderStartValue = sliderStartValue or 1.00
		local frame = CreateFrame("Slider", sliderName, sliderParent or UIParent, "OptionsSliderTemplate")
		frame:SetWidth(sliderWidth)
		if (...) then
			frame:SetPoint(...)
		else
			frame:SetPoint("CENTER")
		end
		
		frame:SetMinMaxValues(sliderMinValue, sliderMaxValue)
		frame:SetValueStep(1)
		_G[frame:GetName() .. 'Low']:SetText(sliderMinValue)
		_G[frame:GetName() .. 'High']:SetText(sliderMaxValue)
		_G[frame:GetName() .. 'Text']:SetText(sliderText)
				
		frame:SetScript("OnMouseWheel", function(self, direction)
			if direction > 0 then
				frame:SetValue(frame:GetValue() + frame:GetValueStep())
			else
				frame:SetValue(frame:GetValue() - frame:GetValueStep())
			end
		end)
		
		frame.editBox = CreateFrame("EditBox",nil,frame,"InputBoxTemplate") 
		frame.editBox:SetSize(64,32) 
		frame.editBox:SetPoint("TOP", frame, "BOTTOM",0,9)
		frame.editBox:SetScale(.7)
		frame.editBox:SetJustifyH("CENTER")
		frame.editBox:SetAutoFocus(false)
		frame.editBox:SetText(sliderStartValue)
	
		frame.editBox:SetScript("OnEnterPressed", function(self)
			local value = self:GetText()
			value = tonumber(value)
			if not value then value = 1 self:SetText(value) end
			self:ClearFocus()		
			frame:SetValue(value)
		end)
		
		frame:SetValue(sliderStartValue)
		
		return frame
	end